unit UMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, Grids, ExtCtrls;
const e=0.01;

type
  TFormMain = class(TForm)
    BbFound: TBitBtn;
    StrGr: TStringGrid;
    LEx: TLabeledEdit;
    LEy: TLabeledEdit;
    LEa: TLabeledEdit;
    procedure BbFoundClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Init;
    procedure LExKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormMain: TFormMain;

implementation

{$R *.dfm}
type
  Tpoint=record
     x:real;
     y:real
   end;
var
  p:Tpoint; 
  count:integer;//  

//    p
function f(p:tpoint):real;
begin
  result:= 4*p.x*p.y+sqr(p.x)+sqr(p.y);
end;

//    p
function grad(p:tpoint):tpoint;
begin
  result.x:=4*p.y+2*p.x;
  result.y:=4*p.x+2*p.y;
end;

// 
function Norma(p:tpoint):real;
begin
  result:=sqrt(Sqr(p.x)+sqr(p.y));
end;

// .
function Newton:tpoint;
var
  grp:Tpoint;
begin
  grp:=grad(p);
  while Norma(grp)>e do
  begin
    p.x:=p.x+grp.x*(1/6)-grp.y*(1/3);
    p.y:=p.y-grp.x*(1/3)+grp.y*(1/6);
    grp:=grad(p);
    inc(count);
  end;
  result:=p;
end;

//  ( ).
function GradientDrob:tpoint;
var
  p1:tpoint;
  grp:Tpoint;
  a:real;// 
begin
  a:=StrToFloat(FormMain.LEa.text);
  grp:=grad(p);                                                                                                                                                                                                                                                                                                     try
  while Norma(grp)>e  do
    begin
      p1.x:=p.x-grp.x*a;
      p1.y:=p.y-grp.y*a;
      if f(p1)<f(p) then p:=p1
      else a:=a/2;
      grp:=grad(p);
      inc(count);
    end;                                                                                                                                                                                                                                                                                                          except  p.x:=0; p.y:=0; count:=count div 10; end;
  result:=p;
end;

//  
function FastDown:tpoint;
var
  grp:Tpoint;
  a:real;
  b,c,u1,u2:Real;
function J(u:Real):Real;
var temp:Tpoint;
begin
  temp.x:=p.x-u*grp.x;
  temp.y:=p.y-u*grp.y;
  result:=f(temp);
end;
begin
  grp:=grad(p);                                                                                                                                                                                                                                                                                                                                                                                                                                                            try
  while Norma(grp)>e  do
    begin                                
      b:=0;
      c:=MAXDWORD;
      while c - b >= e do
        begin
          u1 := (b + c - 0.1 * e) / 2;
          u2 := (b + c + 0.1 * e) / 2;
          if (J(u1) <= J(u2)) then c := u2;
          if (J(u1) >= J(u2)) then b := u1;
        end;
      a := (b + c) / 2;
      p.x:=p.x-grp.x*a;
      p.y:=p.y-grp.y*a;
      grp:=grad(p);
      inc(count);
    end;                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                except  p.x:=0; p.y:=0; count:=count div 10; end;
  result:=p;
end;

procedure TFormMain.Init;
begin
  p.x:=STRtoFLOAT(LEx.Text);
  p.y:=STRtoFLOAT(LEy.Text);
end;

procedure TFormMain.BbFoundClick(Sender: TObject);
var
  xmin:tpoint;
  fmin:real;
begin
  Init;
  count:=0;
  xmin:=Newton;
  fmin:=f(xmin);
  StrGr.Cells[1,1]:=Format('(%0:f;%1:f)', [xmin.x,xmin.y]);
  StrGr.Cells[1,2]:=Format('%0:f', [fmin]);
  StrGr.Cells[1,3]:=inttostr(count);
  Init;
  count:=0;
  xmin:=GradientDrob;
  fmin:=f(xmin);
  StrGr.Cells[2,1]:=Format('(%0:f;%1:f)', [xmin.x,xmin.y]);
  StrGr.Cells[2,2]:=Format('%0:f', [fmin]);
  StrGr.Cells[2,3]:=inttostr(count);
  Init;
  count:=0;
  xmin:=FastDown;
  fmin:=f(xmin);
  StrGr.Cells[3,1]:=Format('(%0:f;%1:f)', [xmin.x,xmin.y]);
  StrGr.Cells[3,2]:=Format('%0:f', [fmin]);
  StrGr.Cells[3,3]:=inttostr(count);
end;

procedure TFormMain.FormCreate(Sender: TObject);
begin
  Init;
  StrGr.Cells[0,1]:='            ' ;
  StrGr.Cells[0,2]:='           ';
  StrGr.Cells[0,3]:='               - ';
  Strgr.Cells[1,0]:=' ';
  Strgr.Cells[2,0]:='  ';
  Strgr.Cells[3,0]:='  ';
end;

procedure TFormMain.LExKeyPress(Sender: TObject; var Key: Char);
begin
 if not (Key in ['0'..'9', '-', ',', #0..#31]) then Key := #0;
end;

end.
